import { __rest } from "tslib";
// @ts-ignore
import { history } from 'umi';
import { createApp as _createApp, } from 'handie-react-starter-antd';
import { Dialog } from '../controls';
import { setRoutes, getLocation, resolveHistoryParams } from './history';
function createAppHelper() {
    return {
        history: {
            getLocation,
            back: history.goBack,
            forward: history.goForward,
            go: history.go,
            push: (location) => history.push(resolveHistoryParams(location)),
            replace: (location) => history.replace(resolveHistoryParams(location)),
        },
        alert: (message, callback) => Dialog.alert(message, callback),
        confirm: (message, ...args) => Dialog.confirm(message, ...args),
    };
}
function createApp(_a) {
    var { routes } = _a, others = __rest(_a, ["routes"]);
    setRoutes(routes);
    return _createApp(Object.assign(Object.assign({}, others), { creators: { appHelper: createAppHelper } }));
}
export { createApp };
